unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Tx4oleLib_TLB, Unit3;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    txtLinkedText: TEdit;
    txtLinkTarget: TEdit;
    btnOK: TButton;
    btnCancel: TButton;
    ListBox1: TListBox;
    Label3: TLabel;
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    Procedure FillListboxWithTargets(Sender : TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  tx : TTXTextControl;

implementation

uses Unit1;

{$R *.DFM}

procedure TForm2.btnCancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
// If the caret is inside an existing hyperlink, copy the hyperlink' text and link
// information to the text boxes on the form.

    tx := Form1.TXTextControl1;

    If (Form1.TXTextControl1.FieldAtInputPos <> 0) Then  begin
        txtLinkedText.Text := tx.FieldText;
        txtLinkTarget.Text := tx.FieldTypeData[Form1.TXTextControl1.FieldCurrent];
    end Else begin
        txtLinkedText.Text := tx.SelText;
        txtLinkTarget.Text := '';
    end;

    FillListboxWithTargets(Sender);
end;

procedure TForm2.btnOKClick(Sender: TObject);
var
   LinkType : Integer;
begin
    If (txtLinkedText.Text = '') Then
        MessageBox(0, 'Hyperlink contains no text. Please enter the text to be shown as a hyperlink in the Linked Text field.', 'ERROR', MB_OK)
    Else If (txtLinkTarget.Text = '') Then
        MessageBox(0, 'No target specified. Please enter a target URL in the Link To field.', 'ERROR', MB_OK)
    Else begin

        LinkType := txFieldInternalLink;

        If tx.FieldAtInputPos <> 0 Then begin
            // editing an existing hyperlink
            tx.FieldText := txtLinkedText.Text;
            tx.FieldType[tx.FieldCurrent] := LinkType;
            tx.FieldTypeData[tx.FieldCurrent] := txtLinkTarget.Text;
        end Else begin
            // insert new hyperlink
            tx.FieldInsert (txtLinkedText.Text);
            tx.FieldType[tx.FieldCurrent] := LinkType;
            tx.FieldTypeData[tx.FieldCurrent] := txtLinkTarget.Text;
            HighlightHyperlinks (tx, Form1.HypertextLinks1.Checked);
        End;
        close;
    End;
end;

//
// FillListboxWithTargets
//
// Loop through all Marked Text Fields which are of type target and add
// them to the listbox.
//
Procedure TForm2.FillListboxWithTargets(Sender : TObject);
var
    FieldID : Integer;
begin
    ListBox1.clear;
    FieldID := tx.FieldNext(0, $100);
    While FieldID <> 0 do begin
        ListBox1.Items.Add(tx.FieldTypeData[FieldID]);
        FieldID := tx.FieldNext(FieldID, $100);
    end;
end;

procedure TForm2.ListBox1Click(Sender: TObject);
begin
     txtLinkTarget.Text := ListBox1.Items.Strings[ListBox1.ItemIndex];
end;

end.
