unit MDIEdit;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, OleCtrls, TXGLOBAL, Tx4oleLib_TLB;

type
  TEditForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    N3: TMenuItem;
    Selectall1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    SaveFileDialog: TSaveDialog;
    FontDialog1: TFontDialog;
    Print1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    Redo1: TMenuItem;
    N1: TMenuItem;
    Undo1: TMenuItem;
    N4: TMenuItem;
    Preview1: TMenuItem;
    Search1: TMenuItem;
    Replace1: TMenuItem;
    N5: TMenuItem;
    View1: TMenuItem;
    Toolbar1: TMenuItem;
    ParagraphBar1: TMenuItem;
    Ruler1: TMenuItem;
    StatusBar1: TMenuItem;
    N6: TMenuItem;
    ControlCharacters1: TMenuItem;
    N7: TMenuItem;
    Zoom1: TMenuItem;
    N301: TMenuItem;
    N501: TMenuItem;
    N751: TMenuItem;
    N1001: TMenuItem;
    N2001: TMenuItem;
    Insert1: TMenuItem;
    InsertText: TMenuItem;
    Image1: TMenuItem;
    Atcaretposition1: TMenuItem;
    Asfixedobject1: TMenuItem;
    Format1: TMenuItem;
    Character1: TMenuItem;
    Textcolor1: TMenuItem;
    Backgroundcolor1: TMenuItem;
    N8: TMenuItem;
    Frames1: TMenuItem;
    Images1: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    Document1: TMenuItem;
    Undo2: TMenuItem;
    N11: TMenuItem;
    Delete2: TMenuItem;
    N12: TMenuItem;
    SelectAll2: TMenuItem;
    TX: TTXTextControl;
    TXRuler1: TTXRuler;
    N13: TMenuItem;
    OLEObject1: TMenuItem;
    Atcaretposition2: TMenuItem;
    Asfixedobject2: TMenuItem;
    Table1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Redo1Click(Sender: TObject);
    procedure Search1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);
    procedure View1Click(Sender: TObject);
    procedure Toolbar1Click(Sender: TObject);
    procedure ParagraphBar1Click(Sender: TObject);
    procedure Ruler1Click(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
    procedure ControlCharacters1Click(Sender: TObject);
    procedure N301Click(Sender: TObject);
    procedure N501Click(Sender: TObject);
    procedure N751Click(Sender: TObject);
    procedure N1001Click(Sender: TObject);
    procedure N2001Click(Sender: TObject);
    procedure Character1Click(Sender: TObject);
    procedure Textcolor1Click(Sender: TObject);
    procedure Backgroundcolor1Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure Frames1Click(Sender: TObject);
    procedure Format1Click(Sender: TObject);
    procedure Atcaretposition1Click(Sender: TObject);
    procedure Images1Click(Sender: TObject);
    procedure Asfixedobject1Click(Sender: TObject);
    procedure TXChange(Sender: TObject);
    procedure Document1Click(Sender: TObject);
    procedure Preview1Click(Sender: TObject);
    procedure InsertTextClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Aboutthisdemo1Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure TXKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Atcaretposition2Click(Sender: TObject);
    procedure Table1Click(Sender: TObject);
    procedure Asfixedobject2Click(Sender: TObject);
  private

  public
    Doc            : DOC_DATA;
    dirty          : boolean;
  end;

var
  EditForm: TEditForm;

const
  DefaultFileName = 'Untitled';

implementation

uses Clipbrd, Printers, MDIFrame, FrameDlg, ImgDlg, FileIO, AboutDlg,
  PageDlg, preview, frmInsertT;

{$R *.DFM}

procedure TEditForm.Exit1Click(Sender: TObject);
begin
  FrameForm.Exit1Click(Sender);
end;

procedure TEditForm.New1Click(Sender: TObject);
begin
  FrameForm.New1Click(Sender);
end;

procedure TEditForm.Open1Click(Sender: TObject);
begin
  FrameForm.Open1Click(Sender);
end;

procedure TEditForm.Cut1Click(Sender: TObject);
begin
  TX.Clip(CLIP_CUT);
end;

procedure TEditForm.Copy1Click(Sender: TObject);
begin
  TX.Clip(CLIP_COPY);
end;

procedure TEditForm.Paste1Click(Sender: TObject);
begin
  TX.Clip(CLIP_PASTE);
end;

procedure TEditForm.Selectall1Click(Sender: TObject);
Var nPointer : Integer;    // MousePointer proterty value
begin
  nPointer := TX.MousePointer;
  TX.MousePointer := 11;
  TX.SelStart := 0;
  TX.SelLength := -1;
  TX.MousePointer := nPointer;
end;

procedure TEditForm.Delete1Click(Sender: TObject);
begin
  TX.Clip(CLIP_CLEAR);
end;

procedure TEditForm.Edit1Click(Sender: TObject);
var
  HasSelection: Boolean;
  UndoState,
  RedoState : Integer;
begin
  Paste1.Enabled := Clipboard.HasFormat(CF_TEXT);
  Paste2.Enabled := Paste1.Enabled;
  HasSelection := TX.SelLength > 0;
  Cut1.Enabled := HasSelection;
  Cut2.Enabled := HasSelection;
  Copy1.Enabled := HasSelection;
  Copy2.Enabled := HasSelection;
  Delete1.Enabled := HasSelection;
  Delete2.Enabled := HasSelection;

  UndoState := TX.CanUndo;
  RedoState := TX.CanRedo;

  Case UndoState of
    UNDO_INSERT : begin
                    Undo1.Caption := '&Undo Input';
                    Undo2.Caption := '&Undo Input';
                  end;
    UNDO_DELETE : begin
                    Undo1.Caption := '&Undo Deletion';
                    Undo2.Caption := '&Undo Deletion';
                  end;
    UNDO_FORMAT : begin
                    Undo1.Caption := '&Undo Formatting';
                    Undo2.Caption := '&Undo Formatting';
                  end;
    Else begin
       Undo1.Caption := '&Undo';
       Undo2.Caption := '&Undo';
     end;
  End; // case

  Case RedoState of
    REDO_INSERT : Redo1.Caption := '&Redo Input';
    REDO_DELETE : Redo1.Caption := '&Redo Deletion';
    REDO_FORMAT : Redo1.Caption := '&Redo Formatting';
    Else Redo1.Caption := '&Redo';
  End; // Case

  Undo1.Enabled := (UndoState <> 0);
  Undo2.Enabled := (UndoState <> 0);
  Redo1.Enabled := (RedoState <> 0);
end;

procedure TEditForm.Saveas1Click(Sender: TObject);
begin
  FileSaveAsProc;
end;

procedure TEditForm.Save1Click(Sender: TObject);
begin
  FileSaveProc;
end;

procedure TEditForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TEditForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
If FrameForm.MDIChildCount = 1 then begin
   FrameForm.Window1.Visible := False;
   FrameForm.TXButtonBar1.Visible := False;
   FrameForm.TXStatusBar1.Visible := False;
   FrameForm.ToolPanel.Visible := False;
end;
  Action := caFree;
end;

procedure TEditForm.FormCloseQuery(Sender: TObject;
var CanClose: Boolean);
const
  SWarningText = 'Save changes to %s?';
begin
  if dirty then begin
    case MessageDlg(Format(SWarningText, [caption]), mtConfirmation,
      [mbYes, mbNo, mbCancel], 0) of
      idYes: Save1Click(Self);
      idCancel: CanClose := False;
    end;
  end;
end;

procedure TEditForm.FormCreate(Sender: TObject);
begin
  inc(FrameForm.CountClients);
  if FrameForm.CountClients <> 1 then
     Caption := DefaultFileName+' '+IntToStr(FrameForm.CountClients)
  else Caption:= DefaultFileName;
  dirty:=false;

  {connecting the controls}
  TX.ButtonBarHandle := FrameForm.TXButtonBar1.Handle;
  TX.RulerHandle := TXRuler1.Handle;
  TX.StatusBarHandle := FrameForm.TXStatusBar1.Handle;

  { Delphi specific: Required for selecting a word with
    double click and for using the OnDblClick event }
  TX.ControlStyle := TX.ControlStyle + [csDoubleClicks];

  TX.ViewMode:=1;//Page view
  TX.FormatSelection:=true;
  Show;

  {Resize controls}
  TX.Height := TEditForm(FrameForm.ActiveMDIChild).ClientHeight - TXRuler1.Height;
  TX.Width := TEditForm(FrameForm.ActiveMDIChild).ClientWidth;
  TXRuler1.Width := TEditForm(FrameForm.ActiveMDIChild).ClientWidth;
  TX.ScrollBars := 3;
  If (TX.Language = 49) Then begin
     glnMeasurement := M_CM;
     TX.PageWidth := DINA4_X;
     TX.PageHeight := DINA4_Y;
   end
  else begin
     glnMeasurement := M_INCH;
     TX.PageWidth := USLET_X;
     TX.PageHeight := USLET_Y;
  End;
end;


procedure TEditForm.Print1Click(Sender: TObject);
Var Copy,
    CurPage,
    StartPage,
    EndPage : Integer;
begin
try
  StartPage := 1;
  EndPage := TX.CurrentPages;

  // Initialize and call the common print dialog
  PrintDialog1.Copies := 1;
  PrintDialog1.FromPage := 1;
  PrintDialog1.ToPage := EndPage;
  PrintDialog1.MinPage := 1;
  PrintDialog1.MaxPage := EndPage;
  PrintDialog1.Options := [poPrintToFile,poPageNums];

  if PrintDialog1.Execute then begin
     // Get first and last page
     If poPageNums in PrintDialog1.Options  Then begin
        StartPage := PrintDialog1.FromPage;
        EndPage := PrintDialog1.ToPage;
      End;

     // Print selected pages
     Printer.BeginDoc;
     For Copy := 1 To PrintDialog1.Copies do begin
        For CurPage := StartPage To EndPage do begin
           TX.PrintDevice := Printer.CanVas.Handle;
           TX.PrintPage(CurPage);
           if (CurPage <> EndPage) then Printer.NewPage;
         end;
      end;
     Printer.EndDoc;
   end;
except
   on EPrinter do MessageDlg('ERROR printing ' + FrameForm.Caption, mtError, [mbOK], 0);
end;
end;

procedure TEditForm.Undo1Click(Sender: TObject);
begin
  TX.Undo;
end;

procedure TEditForm.Redo1Click(Sender: TObject);
begin
  TX.Redo;
end;

procedure TEditForm.Search1Click(Sender: TObject);
begin
  TX.FindReplace(1);
end;

procedure TEditForm.Replace1Click(Sender: TObject);
begin
  TX.FindReplace(2);
end;

procedure TEditForm.View1Click(Sender: TObject);
Var nCount : Integer;
begin
   // Update main checkmarks
   StatusBar1.Checked := FrameForm.TXStatusBar1.Visible;
   ToolBar1.Checked := FrameForm.ToolPanel.Visible;
   ParagraphBar1.Checked := FrameForm.TXButtonBar1.Visible;
   ControlCharacters1.Checked := TX.ControlChars;

   // Update zoom items checkmarks
   For nCount := 0 To 4 do begin
       Zoom1.Items[nCount].Checked := False;
   end;
   Case TX.ZoomFactor of
      30 : Zoom1.Items[0].Checked := True;
      50 : Zoom1.Items[1].Checked := True;
      75 : Zoom1.Items[2].Checked := True;
     100 : Zoom1.Items[3].Checked := True;
     200 : Zoom1.Items[4].Checked := True;
   end;
end;

procedure TEditForm.Toolbar1Click(Sender: TObject);
begin
  FrameForm.ToolPanel.Visible := Not FrameForm.ToolPanel.Visible;
  FrameForm.ToolPanel.Top:=0;
end;

procedure TEditForm.ParagraphBar1Click(Sender: TObject);
begin
   FrameForm.TXButtonBar1.Visible := Not FrameForm.TXButtonBar1.Visible;
   FrameForm.ToolPanel.Top := 0;
end;

procedure TEditForm.Ruler1Click(Sender: TObject);
begin
  TXRuler1.Visible := Not TXRuler1.Visible;
end;

procedure TEditForm.StatusBar1Click(Sender: TObject);
begin
   FrameForm.TXStatusBar1.Visible := Not FrameForm.TXStatusBar1.Visible;
end;

procedure TEditForm.ControlCharacters1Click(Sender: TObject);
begin
  TX.ControlChars := Not TX.ControlChars;
end;

procedure TEditForm.N301Click(Sender: TObject);
begin
  TX.ZoomFactor := 30;
  TXRuler1.Repaint;
end;

procedure TEditForm.N501Click(Sender: TObject);
begin
  TX.ZoomFactor := 50;
  TXRuler1.Repaint;
end;

procedure TEditForm.N751Click(Sender: TObject);
begin
  TX.ZoomFactor := 75;
  TXRuler1.Repaint;
end;

procedure TEditForm.N1001Click(Sender: TObject);
begin
  TX.ZoomFactor := 100;
  TXRuler1.Repaint;
end;

procedure TEditForm.N2001Click(Sender: TObject);
begin
  TX.ZoomFactor := 200;
  TXRuler1.Repaint;
end;

procedure TEditForm.Character1Click(Sender: TObject);
begin
  TX.FontDialog;
end;

procedure TEditForm.Textcolor1Click(Sender: TObject);
Var lOldColor : LongInt;
begin
  lOldColor := TX.ForeColor;

  If lOldColor = -1 Then begin
     FrameForm.ColorDialog1.Color := 0;  // use black if different colors
  end Else begin
     FrameForm.ColorDialog1.Color := lOldColor;
  End;

  if FrameForm.ColorDialog1.Execute then begin
     // set new color
     If (lOldColor = -1) Or (FrameForm.ColorDialog1.Color <> lOldColor) Then begin
        TX.ForeColor := FrameForm.ColorDialog1.Color;
     End;
  end;
end;

procedure TEditForm.Backgroundcolor1Click(Sender: TObject);
Var lOldColor : LongInt;
begin
  lOldColor := TX.TextBKColor;

  If lOldColor = -1 Then begin
     FrameForm.ColorDialog1.Color := 0;  // use black if different colors
  end Else begin
     FrameForm.ColorDialog1.Color := lOldColor;
  End;

  if FrameForm.ColorDialog1.Execute then begin
     // set new color
     If (lOldColor = -1) Or (FrameForm.ColorDialog1.Color <> lOldColor) Then begin
        TX.TextBKColor := FrameForm.ColorDialog1.Color;
     End;
  end;
end;

procedure TEditForm.N8Click(Sender: TObject);
begin
   TX.ParagraphDialog;
end;

procedure TEditForm.Frames1Click(Sender: TObject);
begin
   FramesDlg.ShowModal;
end;

procedure TEditForm.Format1Click(Sender: TObject);
Var a: Integer;
begin
  // Disable Format/Image.. if no image is active
  If TX.ObjectCurrent<>0 Then Images1.Enabled := True
    Else Images1.Enabled := False;
For a := 10 to 100 do begin
  If TX.TableColumns[a] > 0 then begin
     Table1.Enabled := True;
     exit;
     end
    Else Table1.Enabled := False;
  end;
end;

procedure TEditForm.Atcaretposition1Click(Sender: TObject);
begin
  InsertImage(True, TEditForm(FrameForm.ActiveMDIChild).TX, FrameForm.OpenFileDialog, 0, 0);
end;

procedure TEditForm.Asfixedobject1Click(Sender: TObject);
begin
  InsertImage(False, TEditForm(FrameForm.ActiveMDIChild).TX, FrameForm.OpenFileDialog, 1000, 1000);
end;

procedure TEditForm.Images1Click(Sender: TObject);
begin
  ImageDlg.ShowModal;
end;


procedure TEditForm.TXChange(Sender: TObject);
begin
  if dirty = False then dirty := true;
end;

procedure TEditForm.Document1Click(Sender: TObject);
begin
  frmPageDlg.ShowModal;
end;

procedure TEditForm.Preview1Click(Sender: TObject);
begin
  frmPrintPreview.ShowModal;
end;

procedure TEditForm.InsertTextClick(Sender: TObject);
 {Get text file name and import text (ANSI, HTML or RTF)}
var sFileName, Check : String;
begin

  try
    with FrameForm do begin
      OpenFileDialog.Title := 'Insert Text';
      OpenFileDialog.Filter := 'Text (*.txt)|*.txt|RTF Format (*.rtf)|*.rtf|HTML Format(*.htm), (*.html)|*.htm;*.html';
      OpenFileDialog.Options:=[ofPathMustExist, ofOverwritePrompt, ofHideReadOnly];

      if OpenFileDialog.Execute then begin
        sFileName := OpenfileDialog.Filename;
        FrameForm.Cursor:=crHourGlass;   // Hourglass

        Check := UpperCase(copy(sFilename, length(sFilename)-2, 3));
        If Check = 'RTF' Then OpenFile(sFilename, RTF_FILE, True);
        If Check = 'HTM' Then OpenFile(sFilename, HTM_FILE, True); //Check for .htm or .html
        If Check = 'TML' Then OpenFile(sFilename, HTM_FILE, True)  //extension.
        Else OpenFile(sFilename, TXT_FILE, True)
       end;
     end;
  except
    MessageDlg('Can''t import file: ' + sFileName,mtError,[mbOK],0);
    FrameForm.Cursor:=0;   // default
  end;

  FrameForm.Cursor:=0;     // default

end;

procedure TEditForm.FormResize(Sender: TObject);
begin
     TX.Height := TEditForm(FrameForm.ActiveMDIChild).ClientHeight - TXRuler1.Height;
     TX.Width := TEditForm(FrameForm.ActiveMDIChild).ClientWidth;
     TXRuler1.Width := TEditForm(FrameForm.ActiveMDIChild).ClientWidth;
end;

procedure TEditForm.Aboutthisdemo1Click(Sender: TObject);
begin
     frmAbout.ShowModal;
end;

procedure TEditForm.N13Click(Sender: TObject);
begin
     frmInsertTab.Show;
end;

procedure TEditForm.TXKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if Key = 45 Then TX.InsertionMode := Not TX.InsertionMode
end;

procedure TEditForm.Atcaretposition2Click(Sender: TObject);
begin
     InsertObject (True, TEditForm(FrameForm.ActiveMDIChild).TX, 0, 0);
end;

procedure TEditForm.Asfixedobject2Click(Sender: TObject);
begin
    InsertObject (False, TEditForm(FrameForm.ActiveMDIChild).TX, 1000, 1000)
end;

procedure TEditForm.Table1Click(Sender: TObject);
begin
     TEditForm(FrameForm.ActiveMDIChild).TX.TableAttrDialog
end;

end.
