unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, OleCtrls, Tx4oleLib_TLB, StdCtrls, Unit2;

type
  TfrmMain = class(TForm)
    txMain: TTXTextControl;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Insert1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    TextControlAsCharacter1: TMenuItem;
    TextControlAsFixedObject1: TMenuItem;
    N1: TMenuItem;
    ComboBoxAs1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure Unload(control : String; no : Integer);
    function Load(control : String; no : Integer) : TControl;
    procedure Save1Click(Sender: TObject);
    procedure TextControlAsCharacter1Click(Sender: TObject);
    Procedure InsertTX(nAsWhat : Integer);
    Procedure InsertComboBox(nAsWhat : Integer);
    procedure ComboBoxAs1Click(Sender: TObject);
    procedure txMainObjectGetData(Sender: TObject; ObjectIndex: Smallint;
      var ObjectData: OleVariant);
    procedure txMainObjectGethWnd(Sender: TObject; ObjectIndex,
      KindOfObject: Smallint; var hWnd: Integer);
    procedure txMainObjectSetData(Sender: TObject; ObjectIndex: Smallint;
      var ObjectData: OleVariant);
    procedure FormResize(Sender: TObject);
    procedure TextControlAsFixedObject1Click(Sender: TObject);
    procedure txMainSize(Sender: TObject);
  private
    ObjLastCreated : TControl;
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.Open1Click(Sender: TObject);
var
    n : Integer;
begin
    For n := 1 To nTextControls do begin
        Unload ('txIns', n);
    end;
    For n := 1 To nComboBoxes do begin
        Unload ('cbIns', n);
    end;

    nTextControls := 0;
    nComboBoxes := 0;

    txMain.Load ('test.tx', 0, 3, false);
end;

procedure TfrmMain.Unload(control : String; no : Integer);
var
    handle : TComponent;
begin
    handle := FindComponent(control + InttoStr(no));
    handle.Free;
end;

function TfrmMain.Load(control : String; no : Integer) : TControl;
var
    TXNew : TTXTextControl;
    CBNew : TComboBox;
begin
    if(control = 'txIns') then begin
        TXNew := TTXTextControl.Create(frmMain);
        TXNew.Parent := frmMain;
        TXNew.Name := 'txIns' + InttoStr(nTextControls);
        TXNew.SizeMode := 3;
        TXNew.OnSize := txMain.OnSize;
        Load := TXNew;
    end else begin
        CBNew := TComboBox.Create(frmMain);
        CBNew.Parent := frmMain;
        CBNew.Name := 'cbIns' + InttoStr(nComboboxes);
        Load := CBNew;
    end;
end;

procedure TfrmMain.Save1Click(Sender: TObject);
begin
     txMain.Save('test.tx', 0, 3, false);
end;

procedure TfrmMain.TextControlAsCharacter1Click(Sender: TObject);
begin
    nTextControls := nTextControls + 1;
    Load ('txIns', nTextControls);
    InsertTX (INSERT_AS_CHAR);
end;

Procedure TfrmMain.InsertTX(nAsWhat : Integer);
var
    nIndex : Integer;
    ctrl : TTXTextControl;
begin
    // Create a new Text Control

    ctrl := TTXTextControl(FindComponent('txIns' + InttoStr(nTextControls)));
    ctrl.Visible := True;

    If (nAsWhat = INSERT_AS_CHAR) Then
        nIndex := txMain.ObjectInsertAsChar (ctrl.hWnd, FILENAME, TEXTPOS, SCALEFAC, SCALEFAC, 0, 0, TEXT_CONTROL)
    Else If (nAsWhat = INSERT_FIXED) Then
        nIndex := txMain.ObjectInsertFixed (ctrl.hWnd, FILENAME, POSX, POSY, SCALEFAC, SCALEFAC, 0, 0, 0, TEXT_FLOW, TEXT_DIST, TEXT_DIST, TEXT_DIST, TEXT_DIST, TEXT_CONTROL)
    else
        nIndex := -1;

    ctrl.Tag := nIndex;
End;

Procedure TfrmMain.InsertComboBox(nAsWhat : Integer);
var
    nIndex : Integer;
    ctrl : TComboBox;
begin
    // Create a new Combo Box

    ctrl := TComboBox(FindComponent('cbIns' + InttoStr(nComboBoxes)));
    ctrl.Visible := True;

    If (nAsWhat = INSERT_AS_CHAR) Then
        nIndex := txMain.ObjectInsertAsChar(ctrl.handle, FILENAME, TEXTPOS, SCALEFAC, SCALEFAC, 0, 0, COMBO_BOX)
    else
        nIndex := -1;

    // Fill the selected combo box with some test data.
    ctrl.Items.Add('Test Data Item 1');
    ctrl.Items.Add('Test Data Item 2');
    ctrl.Items.Add('Test Data Item 3');
    ctrl.Items.Add('Test Data Item 4');
    ctrl.ItemIndex := 0;

    ctrl.Tag := nIndex;
End;

procedure TfrmMain.ComboBoxAs1Click(Sender: TObject);
begin
    nComboBoxes := nComboBoxes + 1;
    Load ('cbIns', nComboBoxes);
    InsertComboBox (INSERT_AS_CHAR);
end;

procedure TfrmMain.txMainObjectGetData(Sender: TObject;
  ObjectIndex: Smallint; var ObjectData: OleVariant);
var
    objCur : TComponent;
    n : Integer;
    tmp : String;
label go;
begin
    objCur := nil;
    // Find the object for which the data is requested
    For n := 1 To nTextControls do begin
        objCur := FindComponent('txIns' + InttoStr(n));
        If (TTXTextControl(objCur).Tag = ObjectIndex) Then goto go;
    end;
    For n := 1 To nComboBoxes do begin
        objCur := FindComponent('cbIns' + InttoStr(n));
        If (TComboBox(objCur).Tag = ObjectIndex) Then Break;
    End;
go:
    // return the object's data
    If objCur.ClassName = 'TTXTextControl' Then
        // do nothing, data is saved automatically
    Else If objCur.ClassName = 'TComboBox' Then begin
        //save ComboBox data
        tmp := '';
        For n := 0 To TComboBox(objCur).Items.Capacity - 1 do begin
            tmp := tmp + TComboBox(objCur).Items.Strings[n] + '#';
        end;
        ObjectData := tmp;
    End;

end;

procedure TfrmMain.txMainObjectGethWnd(Sender: TObject; ObjectIndex,
  KindOfObject: Smallint; var hWnd: Integer);
var
  TX : TTXTextControl;
  CB : TComboBox;
begin
    // The ObjectGethWnd Event is sent when an object has been loaded from
    // disk or pasted from the clipboard. The KindOfObject parameter tells us
    // what kind of object it is. After this event, an ObjectSetData event is
    // sent.
    if KindOfObject = TEXT_CONTROL then begin
        // Create a new Text Control and return it's window handle
        nTextControls := nTextControls + 1;
        TX := TTXTextControl(Load ('txIns', nTextControls));
        TX.Visible := True;
        TX.Tag := ObjectIndex;
        hWnd := TX.hWnd;
        ObjLastCreated := TX;
    end else if KindOfObject = COMBO_BOX then begin
        // Create a new Combo Box and return it's window handle
        nComboBoxes := nComboBoxes + 1;
        CB := TComboBox(Load ('cbIns', nTextControls));
        CB.Visible := True;
        CB.Tag := ObjectIndex;
        hWnd := CB.Handle;
        ObjLastCreated := CB;
    end;
end;

procedure TfrmMain.txMainObjectSetData(Sender: TObject;
  ObjectIndex: Smallint; var ObjectData: OleVariant);
var
    s : String;
    iPos : Integer;
begin
    // This event is sent when an object has been loaded from disk
    // or pasted from the clipboard. The ObjectData parameter contains
    // the data which has been returned from the ObjectGetData Event
    // when the object was copied or saved.

    If ObjLastCreated.ClassName = 'TComboBox' Then begin
        s := ObjectData;
        While s <> '' do begin
            iPos := pos('#', s);
            TComboBox(ObjLastCreated).Items.add(copy(s, 1, iPos - 1));
            s := copy(s, iPos + 1, length(s));
        end;
        TComboBox(ObjLastCreated).ItemIndex := 0;
    End;
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
    // Resize the main Text Control so that has the same
    // height as the main window.
    txMain.Height := ClientHeight;
    txMain.Width := ClientWidth;
end;

procedure TfrmMain.TextControlAsFixedObject1Click(Sender: TObject);
begin
    nTextControls := nTextControls + 1;
    Load ('txIns', nTextControls);
    InsertTX (INSERT_FIXED);
end;

procedure TfrmMain.txMainSize(Sender: TObject);
begin
     txMain.Refresh;
end;

end.
