unit ImgDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Module1;

type
  TImageDlg = class(TForm)
    GroupBox1: TGroupBox;
    chkFastDisplay: TCheckBox;
    chkSaveAsData: TCheckBox;
    BorderGroup: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    txtTopBorder: TEdit;
    txtLeftBorder: TEdit;
    txtRightBorder: TEdit;
    txtBottomBorder: TEdit;
    cmdOK: TButton;
    cmdCancel: TButton;
    procedure FormShow(Sender: TObject);
    procedure cmdOKClick(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
  private

  public

  end;

var
  ImageDlg: TImageDlg;

implementation

uses main, TXGlobal;

{$R *.DFM}

procedure TImageDlg.FormShow(Sender: TObject);
begin
  {Initialize the dialog box controls.

   Set borders. If the object has been inserted as character,
   then no borders can be specified and the controls are grayed.}

  with ctrParam do
   begin
     If ObjectTextflow = EOM_INSERT Then
      begin
        txtLeftBorder.Enabled := False;
        txtTopBorder.Enabled := False;
        txtRightBorder.Enabled := False;
        txtBottomBorder.Enabled := False;

        Label1.Enabled := False;
        Label2.Enabled := False;
        Label3.Enabled := False;
        Label4.Enabled := False;

        BorderGroup.Enabled := False;
      end
     Else
      begin
        txtLeftBorder.Text := Twips2DlgString(ObjectDistance[1]);
        txtTopBorder.Text := Twips2DlgString(ObjectDistance[2]);
        txtRightBorder.Text := Twips2DlgString(ObjectDistance[3]);
        txtBottomBorder.Text := Twips2DlgString(ObjectDistance[4]);

        Label1.Enabled := true;
        Label2.Enabled := true;
        Label3.Enabled := true;
        Label4.Enabled := true;

        BorderGroup.Enabled := true;
     end; // if


     // Display mode and 'save as data'
     chkFastDisplay.Checked := (ImageDisplayMode = 1);
     chkSaveAsData.Checked := (ImageSaveMode = 1);

     // Set measurement string ('inch' or 'cm')
     { }

   end; // with
end;

procedure TImageDlg.cmdOKClick(Sender: TObject);
begin
  with ctrParam do
   begin
     If (ObjectTextflow <> EOM_INSERT) Then
      begin
       ObjectDistance[1] := DlgString2Twips(txtLeftBorder.Text);
       ObjectDistance[2] := DlgString2Twips(txtTopBorder.Text);
       ObjectDistance[3] := DlgString2Twips(txtRightBorder.Text);
       ObjectDistance[4] := DlgString2Twips(txtBottomBorder.Text);
      end;
     if chkFastDisplay.Checked then ImageDisplayMode:=1 else ImageDisplayMode:=0;
     if chkSaveAsData.Checked then ImageSaveMode:=1 else ImageSaveMode:=0;
   end;
  Close;
end;

procedure TImageDlg.cmdCancelClick(Sender: TObject);
begin
  close;
end;

end.
